#include <stdio.h>
#include <string.h>


typedef unsigned long word32;
typedef unsigned char byte;

#if defined(BIG_ENDIAN) && defined(LITTLE_ENDIAN) 
 #if BYTE_ORDER==LITTLE_ENDIAN
  #undef BIG_ENDIAN
 #endif
 #if BYTE_ORDER==BIG_ENDIAN
  #undef LITTLE_ENDIAN
 #endif
#else
 #if defined(__BORLANDC__)||defined(_MSC_VER)||defined(DJGPP)||defined(MSDOS)||defined(WIN32)||defined(i386)||defined(_X86)||defined(_M_IX86)||defined(_M_I86)
  #define __i386__
 #endif
 #if !(defined(__alpha)||defined(__i386__)||defined(__vax__))
  /* Big endian:                                         */
  #define BIG_ENDIAN
 #endif
#endif

/* NOTE that this code is NOT FULLY OPTIMIZED for any  */
/* machine. Assembly code might be much faster on some */
/* machines, especially if the code is compiled with   */
/* gcc.                                                */

/* The number of passes of the hash function.          */
/* Three passes are recommended.                       */
/* Use four passes when you need extra security.       */
/* Must be at least three.                             */
#define PASSES 3

extern word32 table[4*256][2];
#include "tigerbox.h"

#define t1 (table)
#define t2 (table+256)
#define t3 (table+256*2)
#define t4 (table+256*3)

#define sub64(s0, s1, p0, p1) \
      temps0 = (p0); \
      tcarry = s0 < temps0; \
      s0 -= temps0; \
      s1 -= (p1) + tcarry;

#define add64(s0, s1, p0, p1) \
      temps0 = (p0); \
      s0 += temps0; \
      tcarry = s0 < temps0; \
      s1 += (p1) + tcarry;

#define xor64(s0, s1, p0, p1) \
      s0 ^= (p0); \
      s1 ^= (p1);

#define mul5(s0, s1) \
      tempt0 = s0<<2; \
      tempt1 = (s1<<2)|(s0>>30); \
      add64(s0, s1, tempt0, tempt1);

#define mul7(s0, s1) \
      tempt0 = s0<<3; \
      tempt1 = (s1<<3)|(s0>>29); \
      sub64(tempt0, tempt1, s0, s1); \
      s0 = tempt0; \
      s1 = tempt1;

#define mul9(s0, s1) \
      tempt0 = s0<<3; \
      tempt1 = (s1<<3)|(s0>>29); \
      add64(s0, s1, tempt0, tempt1);

#define save_abc \
      aa0 = a0; \
      aa1 = a1; \
      bb0 = b0; \
      bb1 = b1; \
      cc0 = c0; \
      cc1 = c1;

#define roundX(a0,a1,b0,b1,c0,c1,x0,x1,mul) \
      xor64(c0, c1, x0, x1); \
      temp0  = t1[((c0)>>(0*8))&0xFF][0] ; \
      temp1  = t1[((c0)>>(0*8))&0xFF][1] ; \
      temp0 ^= t2[((c0)>>(2*8))&0xFF][0] ; \
      temp1 ^= t2[((c0)>>(2*8))&0xFF][1] ; \
      temp0 ^= t3[((c1)>>(0*8))&0xFF][0] ; \
      temp1 ^= t3[((c1)>>(0*8))&0xFF][1] ; \
      temp0 ^= t4[((c1)>>(2*8))&0xFF][0] ; \
      temp1 ^= t4[((c1)>>(2*8))&0xFF][1] ; \
      sub64(a0, a1, temp0, temp1); \
      temp0  = t4[((c0)>>(1*8))&0xFF][0] ; \
      temp1  = t4[((c0)>>(1*8))&0xFF][1] ; \
      temp0 ^= t3[((c0)>>(3*8))&0xFF][0] ; \
      temp1 ^= t3[((c0)>>(3*8))&0xFF][1] ; \
      temp0 ^= t2[((c1)>>(1*8))&0xFF][0] ; \
      temp1 ^= t2[((c1)>>(1*8))&0xFF][1] ; \
      temp0 ^= t1[((c1)>>(3*8))&0xFF][0] ; \
      temp1 ^= t1[((c1)>>(3*8))&0xFF][1] ; \
      add64(b0, b1, temp0, temp1); \
      if((mul)==5) \
    {mul5(b0, b1);} \
      else \
    if((mul)==7) \
      {mul7(b0, b1);} \
    else \
      {mul9(b0, b1)};
#if defined(_MSC_VER) && defined(MSDOS)
void round(word32 *a0,word32 *a1,word32 *b0,word32 *b1,word32 *c0,word32 *c1,word32 x0,word32 x1,word32 mul)
{
  register word32 temp0, temp1, tempt0, tempt1, temps0, tcarry;
    roundX(*a0,*a1,*b0,*b1,*c0,*c1,x0,x1,mul)
}
#else
#define round(a0,a1,b0,b1,c0,c1,x0,x1,mul) roundX(a0,a1,b0,b1,c0,c1,x0,x1,mul)
#endif

#define passX(a0,a1,b0,b1,c0,c1,mul) \
      round(a0,a1,b0,b1,c0,c1,x00,x01,mul); \
      round(b0,b1,c0,c1,a0,a1,x10,x11,mul); \
      round(c0,c1,a0,a1,b0,b1,x20,x21,mul); \
      round(a0,a1,b0,b1,c0,c1,x30,x31,mul); \
      round(b0,b1,c0,c1,a0,a1,x40,x41,mul); \
      round(c0,c1,a0,a1,b0,b1,x50,x51,mul); \
      round(a0,a1,b0,b1,c0,c1,x60,x61,mul); \
      round(b0,b1,c0,c1,a0,a1,x70,x71,mul);
#if defined(_MSC_VER) && defined(MSDOS)
#define pass(a0,a1,b0,b1,c0,c1,mul) passX(&a0,&a1,&b0,&b1,&c0,&c1,mul)
#else
#define pass(a0,a1,b0,b1,c0,c1,mul) passX(a0,a1,b0,b1,c0,c1,mul)
#endif

#define key_schedule \
      sub64(x00, x01, x70^0xA5A5A5A5, x71^0xA5A5A5A5); \
      xor64(x10, x11, x00, x01); \
      add64(x20, x21, x10, x11); \
      sub64(x30, x31, x20^((~x10)<<19), ~x21^(((x11)<<19)|((x10)>>13))); \
      xor64(x40, x41, x30, x31); \
      add64(x50, x51, x40, x41); \
      sub64(x60, x61, ~x50^(((x40)>>23)|((x41)<<9)), x51^((~x41)>>23)); \
      xor64(x70, x71, x60, x61); \
      add64(x00, x01, x70, x71); \
      sub64(x10, x11, x00^((~x70)<<19), ~x01^(((x71)<<19)|((x70)>>13))); \
      xor64(x20, x21, x10, x11); \
      add64(x30, x31, x20, x21); \
      sub64(x40, x41, ~x30^(((x20)>>23)|((x21)<<9)), x31^((~x21)>>23)); \
      xor64(x50, x51, x40, x41); \
      add64(x60, x61, x50, x51); \
      sub64(x70, x71, x60^0x89ABCDEF, x61^0x01234567);

#define feedforward \
      xor64(a0, a1, aa0, aa1); \
      sub64(b0, b1, bb0, bb1); \
      add64(c0, c1, cc0, cc1);

#ifdef UNROLL_COMPRESS
#define compress \
      save_abc \
      pass(a0,a1,b0,b1,c0,c1,5); \
      key_schedule; \
      pass(c0,c1,a0,a1,b0,b1,7); \
      key_schedule; \
      pass(b0,b1,c0,c1,a0,a1,9); \
      for(pass_no=3; pass_no<PASSES; pass_no++) { \
        key_schedule \
    pass(a0,a1,b0,b1,c0,c1,9); \
    tmpa=a0; a0=c0; c0=b0; b0=tmpa; \
    tmpa=a1; a1=c1; c1=b1; b1=tmpa;} \
      feedforward
#else
#define compress \
      save_abc \
      for(pass_no=0; pass_no<PASSES; pass_no++) { \
        if(pass_no != 0) {key_schedule} \
    pass(a0,a1,b0,b1,c0,c1,(pass_no==0?5:pass_no==1?7:9)) \
    tmpa=a0; a0=c0; c0=b0; b0=tmpa; \
    tmpa=a1; a1=c1; c1=b1; b1=tmpa;} \
      feedforward
#endif

#define tiger_compress_macro(str, state) \
{ \
  /*register*/ word32 a0, a1, b0, b1, c0, c1, tmpa; \
  word32 aa0, aa1, bb0, bb1, cc0, cc1; \
  word32 x00, x01, x10, x11, x20, x21, x30, x31, \
         x40, x41, x50, x51, x60, x61, x70, x71; \
  register word32 temp0, temp1, tempt0, tempt1, temps0, tcarry; \
  word32 i; \
  int pass_no; \
\
  a0 = state[0]; \
  a1 = state[1]; \
  b0 = state[2]; \
  b1 = state[3]; \
  c0 = state[4]; \
  c1 = state[5]; \
\
  x00=str[0*2]; x01=str[0*2+1]; x10=str[1*2]; x11=str[1*2+1]; \
  x20=str[2*2]; x21=str[2*2+1]; x30=str[3*2]; x31=str[3*2+1]; \
  x40=str[4*2]; x41=str[4*2+1]; x50=str[5*2]; x51=str[5*2+1]; \
  x60=str[6*2]; x61=str[6*2+1]; x70=str[7*2]; x71=str[7*2+1]; \
\
  compress; \
\
  state[0] = a0; \
  state[1] = a1; \
  state[2] = b0; \
  state[3] = b1; \
  state[4] = c0; \
  state[5] = c1; \
}

#ifdef UNROLL_COMPRESS
/* The compress function is inlined */
#define tiger_compress(str, state) \
  tiger_compress_macro(((word32*)str), ((word32*)state))
#else
/* The compress function is a function */
void tiger_compress(word32 *str, word32 state[6])
{
  tiger_compress_macro(((word32*)str), ((word32*)state));
}
#endif

void tiger(word32 *str, word32 length, word32 res[6])
{
  register word32 i, j;
  byte temp[64];

  res[0]=0x89ABCDEF;
  res[1]=0x01234567;
  res[2]=0x76543210;
  res[3]=0xFEDCBA98;
  res[4]=0xC3B2E187;
  res[5]=0xF096A5B4;

  for(i=length; i>=64; i-=64)
    {
#ifdef BIG_ENDIAN
      for(j=0; j<64; j++)
    temp[j^3] = ((byte*)str)[j];
      tiger_compress(((word32*)temp), res);
#else
      tiger_compress(str, res);
#endif
      str += 16;
    }

#ifdef BIG_ENDIAN
  for(j=0; j<i; j++)
    temp[j^3] = ((byte*)str)[j];

  temp[j^3] = 0x01;
  j++;
  for(; j&7; j++)
    temp[j^3] = 0;
#else
  for(j=0; j<i; j++)
    temp[j] = ((byte*)str)[j];

  temp[j++] = 0x01;
  for(; j&7; j++)
    temp[j] = 0;
#endif
  if(j>56)
    {
      for(; j<64; j++)
    temp[j] = 0;
      tiger_compress(((word32*)temp), res);
      j=0;
    }

  for(; j<56; j++)
    temp[j] = 0;
  ((word32*)(&(temp[56])))[0] = ((word32)length)<<3;
  ((word32*)(&(temp[56])))[1] = ((word32)length)>>29; /* ???????? was = 0 */
  tiger_compress(((word32*)temp), res);
}

/*---------------------------------------------------------*/

#include "tiger.h"


static int selftest_done = 0;
void tigerinit(struct tiger_ctx *tctx)
{
#if defined(TEST_HASH) || defined(_DEBUG) || defined(DEBUG)
    char in1[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-";
                  //87FB2A9083851CF7 470D2CF810E6DF9E B586445034A5A386
    char in2[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-";
                  //00B83EB4E53440C5 76AC6AAEE0A74858 25FD15E70A59FFE4
    byte out0[24];
    byte out1[24] = {0xF7, 0x1C, 0x85, 0x83, 0x90, 0x2A, 0xFB, 0x87,
                     0x9E, 0xDF, 0xE6, 0x10, 0xF8, 0x2C, 0x0D, 0x47,
                     0x86, 0xA3, 0xA5, 0x34, 0x50, 0x44, 0x86, 0xB5};
    byte out2[24] = {0xC5, 0x40, 0x34, 0xE5, 0xB4, 0x3E, 0xB8, 0x00,
                     0x58, 0x48, 0xA7, 0xE0, 0xAE, 0x6A, 0xAC, 0x76,
                     0xE4, 0xFF, 0x59, 0x0A, 0xE7, 0x15, 0xFD, 0x25};
    if (!selftest_done) {
        selftest_done = 1;
        tiger((word32 *)in1, strlen(in1), (word32 *)out0);
        if (memcmp(out0, out1, 20)) {
            fprintf(stderr, "\n\nTIGER192 Selftest 0 failed!\n\n");
        }
        tigerinit(tctx);
        tigerUpdate(tctx, in1, strlen(in1));
        tigerFinal(out0, tctx);
        if (memcmp(out0, out1, 20)) {
            fprintf(stderr, "\n\nTIGER192 Selftest 1 failed!\n\n");
        }
        tigerinit(tctx);
        tigerUpdate(tctx, in2, strlen(in2));
        tigerFinal(out0, tctx);
        if (memcmp(out0, out2, 20)) {
            fprintf(stderr, "\n\nTIGER192 Selftest 2 failed!\n\n");
        }
        tigerinit(tctx);
        tigerUpdate(tctx, in2, 5);
        tigerUpdate(tctx, in2+5, 65);
        tigerUpdate(tctx, in2+70, strlen(in2)-70);
        tigerFinal(out0, tctx);
        if (memcmp(out0, out2, 20)) {
            fprintf(stderr, "\n\nTIGER192 Selftest 3 failed!\n\n");
        }
    }
#endif
  tctx->res[0]=0x89ABCDEF;
  tctx->res[1]=0x01234567;
  tctx->res[2]=0x76543210;
  tctx->res[3]=0xFEDCBA98;
  tctx->res[4]=0xC3B2E187;
  tctx->res[5]=0xF096A5B4;
  memset(tctx->temp, 0, sizeof(tctx->temp));
  tctx->eptr = 0;
  tctx->lenHi = tctx->lenLo = 0;
}

void tigerUpdate(struct tiger_ctx *tctx, byte const * buf, word32 len)
{
  register word32 i, j;
  byte *temp;

  i = tctx->lenLo;
  tctx->lenLo += len;
  if (tctx->lenLo < i)
    tctx->lenHi++;

  temp = tctx->temp;
  for(i=len+tctx->eptr; i>=64; i-=64)
    {
      for(j=tctx->eptr; j<64; j++)
#ifdef BIG_ENDIAN
        temp[j^3] = *buf++;
#else
        temp[j] = *buf++;
#endif
      tiger_compress(((word32*)temp), tctx->res);
      tctx->eptr = 0;
    }

  for(j=tctx->eptr; j<i; j++)
#ifdef BIG_ENDIAN
    temp[j^3] = *buf++;
#else
    temp[j] = *buf++;
#endif
  tctx->eptr = j;
}

void tigerFinal(byte *buf, struct tiger_ctx *tctx)
{
  register word32 j;
  byte *temp;

  j = tctx->eptr;
  temp = tctx->temp;
#ifdef BIG_ENDIAN
  temp[j^3] = 0x01;
  j++;
  for(; j&7; j++)
    temp[j^3] = 0;
#else
  temp[j++] = 0x01;
  for(; j&7; j++)
    temp[j] = 0;
#endif


  if(j>56)
    {
      for(; j<64; j++)
    temp[j] = 0;
      tiger_compress(((word32*)temp), tctx->res);
      j=0;
    }

  for(; j<56; j++)
    temp[j] = 0;
  ((word32*)(&(temp[56])))[0] = ((word32)tctx->lenLo)<<3;
  ((word32*)(&(temp[56])))[1] = ((word32)tctx->lenHi)<<3 | ((word32)tctx->lenLo)>>29;
  tiger_compress(((word32*)temp), tctx->res);
  memcpy(buf, tctx->res, 24);
  tigerinit(tctx);
//{ int iii; for (iii=0;iii<24;iii++) fprintf(stderr, "%02X ", (int)buf[iii]); fprintf(stderr, "\n"); }
}
